#ifndef SHORTVEGEVAP_H
#define SHORTVEGEVAP_H
///////////////////////////////////////////////////////////////////////////////////////
//																		             //
// ShortVegEvaporation.h - Calculates short veg evaporation                          //																		   
// ver 1.0                                                                           //
// Language:    Visual C++ 2010                                                      //
// Platform:    MacBookPro5,4  Win7										             //
// Application: HydroPrime/iHydro Version6, Summer 2012                              //
// Programmer:  				             //																	   	
///////////////////////////////////////////////////////////////////////////////////////
/*
  Origin:
  ==================
  Program: iHydro Version 5
  
  Source Code File(s): VegInterception.cpp
  Functions:           V5 - (line 491) ShortVegEvaporation()
  
  Author(s): Yang Yang, yyang31@syr.edu, V5
			  	
						*Incorporated calculations into new architecture
  Creation Date: 03 June 2010

  Publication(s): 

  Module Operations: 
  ==================
  

  Public Interface:
  =================
  ShortVegEvaporationCalc(Inputs *input, Repo *repo);
  void calculate(Inputs *input, DataFolder *folder, int timeStep);

  Build Process:
  ==============
  Required files
	-ICalc.h, InputsRepository.h, ResultsRepository.h, ShortVegEvaporation.cpp 
				
  Build commands 
    - devenv hydroprime.sln
   
  Maintenance History:
  ====================

 */
#include "../Inputs/Inputs.h"
#include "../DataFolder.h"

class ShortVegEvaporationCalc
{
	public:
		
		static void calculateShortVegEvaporationStatistical(Inputs *input, DataFolder *folder, int timeStep);
		static void calculateShortVegEvaporationTemperature(Inputs *input, DataFolder *folder, int timeStep);
};



#endif