#pragma once
#include "../Inputs/Inputs.h"
#include "../DataFolder.h"
#include <fstream>
#include <iomanip>
#include <iostream>

class GIOutputWriter
{
public:
	// BulkArea
	static void writeVegCanopyFile_VWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeVegCanopyFile_FWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterOnPerAreaFile_VWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterOnPerAreaFile_FWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterOnImpAreaFile_VWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterOnImpAreaFile_FWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_VWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_FWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterInRootZone_VWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterInRootZone_FWB_BulkArea(Inputs *input, DataFolder *folder);

	// Rain Garden
	static void writeWaterBalance_RainGarden(Inputs *input, DataFolder *folder);

	static void writeVegCanopyFile_VWB_RainGarden(Inputs *input, DataFolder *folder);
	static void writeVegCanopyFile_FWB_RainGarden(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_VWB_RainGarden(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_FWB_RainGarden(Inputs *input, DataFolder *folder);

	// BioRetention
	static void writeWaterBalance_BioRetention(Inputs *input, DataFolder *folder);

	static void writeVegCanopyFile_VWB_BioRetention(Inputs *input, DataFolder *folder);
	static void writeVegCanopyFile_FWB_BioRetention(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_VWB_BioRetention(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_FWB_BioRetention(Inputs *input, DataFolder *folder);
	
	// InfilTrench
	static void writeWaterBalance_InfilTrench(Inputs *input, DataFolder *folder);

	// Swale
	static void writeWaterBalance_Swale(Inputs *input, DataFolder *folder);

	// Porous Pavement  
	static void writeWaterBalance_PermeablePavement(Inputs* input, DataFolder* folder);
		// Need to modify the below functions if needed
	static void writeVegCanopyFile_VWB_PermeablePavement(Inputs *input, DataFolder *folder);
	static void writeVegCanopyFile_FWB_PermeablePavement(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_VWB_PermeablePavement(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_FWB_PermeablePavement(Inputs *input, DataFolder *folder);

	
	// Green Roof Added by Li
	static void writeWaterBalance_GreenRoof(Inputs* input, DataFolder* folder);
	static void writeVegCanopyFile_VWB_GreenRoof(Inputs* input, DataFolder* folder);
	static void writeVegCanopyFile_FWB_GreenRoof(Inputs* input, DataFolder* folder);
	static void writeEvap_ET_Infil_VWB_GreenRoof(Inputs* input, DataFolder* folder);
	static void writeEvap_ET_Infil_FWB_GreenRoof(Inputs* input, DataFolder* folder);

	// Rooftop disconnection Added by Li
	static void writeWaterBalance_RoofDiscon(Inputs* input, DataFolder* folder);
	static void writeVegCanopyFile_VWB_RoofDiscon(Inputs* input, DataFolder* folder);
	static void writeVegCanopyFile_FWB_RoofDiscon(Inputs* input, DataFolder* folder);
	static void writeEvap_ET_Infil_VWB_RoofDiscon(Inputs* input, DataFolder* folder);
	static void writeEvap_ET_Infil_FWB_RoofDiscon(Inputs* input, DataFolder* folder);
	
	// Rain Barrel - Need to modify the below functions if needed
	static void writeFlow_VWB_RainBarrel(Inputs *input, DataFolder *folder);
	static void writeFlow_FWB_RainBarrel(Inputs *input, DataFolder *folder);
	//Added by Li:
	static void writeWaterBalance_RainBarrel(Inputs* input, DataFolder* folder);
	static void writeWaterInRootZone_VWB_RainBarrel(Inputs* input, DataFolder* folder);
	static void writeWaterInRootZone_FWB_RainBarrel(Inputs* input, DataFolder* folder);

	// Tree Pit - Should be working 
	static void writeVegCanopyFile_VWB_TreePit(Inputs *input, DataFolder *folder);
	static void writeVegCanopyFile_FWB_TreePit(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_VWB_TreePit(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_FWB_TreePit(Inputs *input, DataFolder *folder);
	static void writeWaterInRootZone_VWB_TreePit(Inputs *input, DataFolder *folder);
	static void writeWaterInRootZone_FWB_TreePit(Inputs *input, DataFolder *folder);


};