#include "SaturatedBaseFlowExpDecayCalc.h"


//------------------------base flow calculation ---------------------------------------/

void SaturatedBaseFlowExpDecayCalc::calculate(Inputs *input, DataFolder *folder, int timeStep)
{

//the following sequence of calculations are based on Yang's TestWeather Version 5 rsatzoneE.cpp package
//void rsatzoneE::baseQ(){

	double satZoneQ =0.0;
	double mM = folder->ParamDict["m"];
	double T0 = folder->ParamDict["T0_m2ph"]; // from ParamDict since it is structure specific, not universal SoilParam

	// Initializing baseflow to 0.0
	folder->VarDict["baseFlow"] = 0.0;
	double aveSMD = input->AveSMD;

	satZoneQ = folder->ParamDict["BF_flag"] * T0*exp(-input->AverageIndex);
	// baseflow is (decayed transmissivity * (1 - average soil moisture deficit / M) ^ N
	folder->VarDict["baseFlow"] = (satZoneQ * exp(-folder->VarDict["aveSMD"] / mM));

	// storing this folder's baseflow value in the timestep
	// doing this in the FlowSumCalc
	//folder->VarDict["baseFlow"]_vec.emplace_back(folder->VarDict["baseFlow"]);    


}

/*
void rsatzoneE::baseQ(){

	double SZQ =0.0;
	BQ = 0.0;
	SZQ = T0*exp(-topIndex.getAveIndex());
	BQ = SZQ*exp(-aveSMD/mM);
    
}
*/

