
#ifndef SATFLOWEXPDECAY_H
#define SATFLOWEXPDECAY_H
//////////////////////////////////////////////////////////////////////////////////
//																		        //
// SaturatedBaseFlowExpDecay.h - Calculates saturated base flow                 //																		   
// ver 1.0                                                                      //
// Language:    Visual C++ 2010                                                 //
// Platform:    MacBookPro5,4  Win7										        //
// Application: HydroPrime/iHydro Version6, Summer 2012                         //
// Programmer:  				        //																	   	
//////////////////////////////////////////////////////////////////////////////////
/*
  Origin:
  ==================
  Program: iHydro Version 5 & iHydro Version 4.5
  
  Source Code File(s): rsatzoneE.cpp
  Functions:           V5 - (line 28) baseQ()
                       V4.5 - (line 28) baseQ()
  
  Author(s): Jun Wang, jwang06@mailbox.syr.edu, Original author V4/V4.5
             Yang Yang, yyang31@syr.edu, V5
			  	
						*Incorporated calculations into new architecture
  Creation Date: Summer 2000

  Publication(s): Jun Wang PHDThesis

  Module Operations: 
  ==================
  

  Public Interface:
  =================
  SaturatedBaseFlowExpDecayCalc(Inputs *input, Repo *repo);
  void calculate(Inputs *input, DataFolder *folder, int timeStep);

  Build Process:
  ==============
  Required files
	-ICalc.h, InputsRepository.h, ResultsRepository.h, SaturatedBaseFlowExpDecay.cpp 
				
  Build commands 
    - devenv hydroprime.sln
   
  Maintenance History:
  ====================

 */


#include "../Inputs/Inputs.h"
#include "../DataFolder.h"


class SaturatedBaseFlowExpDecayCalc
{
	public:
		static void calculate(Inputs *input, DataFolder *folder, int timeStep);
};



#endif




// see SaturatedBaseFlow.h for interface
// remeber to make inputs repository and results repository a friend of this class...inputsrepository.cpp resultsrepository.cpp
// see SaturatedBaseFlow.cpp for inplentation help 
// incporporate equation from Version 5 line 28 rsatzoneE.cpp void rsatzoneE::baseQ(){