#ifndef SNOWMELTO_H
#define SNOWMELTO_H
///////////////////////////////////////////////////////////////////////////////////////
//																		             //
// SnowMeltOpenArea.h - Calculates snow melt on open area                             //																		   
// ver 1.0                                                                           //
// Language:    Visual C++ 2010                                                      //
// Platform:    MacBookPro5,4  Win7										             //
// Application: HydroPrime/iHydro Version6, Summer 2012                              //
// Programmer:  				             //																	   	
///////////////////////////////////////////////////////////////////////////////////////
/*
  Origin:
  ==================
  Program: iHydro Version 5
  
  Source Code File(s): SnowMelt.cpp
  Functions:           V5 - (line 32) SnowMeltOpenArea()
  
  Author(s): Yang Yang, yyang31@syr.edu, V5
			  	
						*Incorporated calculations into new architecture
  Creation Date: 04 June 2010

  Publication(s): 

  Module Operations: 
  ==================
  

  Public Interface:
  =================
  SnowMeltOpenAreaCalc(Inputs *input, Repo *repo);
  void calculate(Inputs *input, DataFolder *folder, int timeStep);

  Build Process:
  ==============
  Required files
	-ICalc.h, InputsRepository.h, ResultsRepository.h, SnowMeltOpenArea.cpp 
				
  Build commands 
    - devenv hydroprime.sln
   
  Maintenance History:
  ====================
  */

#include "../Inputs/Inputs.h"
#include "../DataFolder.h"


class SnowMeltOpenAreaCalc 
{
	public:
		static void calculate(Inputs *input, DataFolder *folder, int timeStep);
		static void meltsnowOpen(Inputs *input, DataFolder *folder, int timeStep);
		static void storeValues(Inputs *input, DataFolder *folder, int timeStep);
};



#endif