#ifndef SNOWMELTU_H
#define SNOWMELTU_H
///////////////////////////////////////////////////////////////////////////////////////
//																		             //
// SnowMeltUnderShortVeg.h - Calculates snow melt under short veg                    //																		   
// ver 1.0                                                                           //
// Language:    Visual C++ 2010                                                      //
// Platform:    MacBookPro5,4  Win7										             //
// Application: HydroPrime/iHydro Version6, Summer 2012                              //
// Programmer:  				             //																	   	
///////////////////////////////////////////////////////////////////////////////////////
/*
  Origin:
  ==================
  Program: iHydro Version 5
  
  Source Code File(s): SnowMelt.cpp
  Functions:           V5 - (line 161) SnowMeltUnderShortVeg()
  
  Author(s): Yang Yang, yyang31@syr.edu, V5
			  	
						*Incorporated calculations into new architecture
  Creation Date: 04 June 2010

  Publication(s): 

  Module Operations: 
  ==================
  

  Public Interface:
  =================
  SnowMeltUnderShortVegCalc(Inputs *input, Repo *repo);
  void calculate(Inputs *input, DataFolder *folder, int timeStep);

  Build Process:
  ==============
  Required files
	-ICalc.h, InputsRepository.h, ResultsRepository.h, SnowMeltUnderShortVeg.cpp 
				
  Build commands 
    - devenv hydroprime.sln
   
  Maintenance History:
  ====================
  */

#include "../Inputs/Inputs.h"
#include "../DataFolder.h"


class SnowMeltUnderShortVegCalc
{
	public:
		static void calculate(Inputs *input, DataFolder *folder, int timeStep);
		static void meltsnowUnderShortVeg(Inputs *input, DataFolder *folder, int timeStep);
		static void storeValues(Inputs *input, DataFolder *folder, int timeStep);
};



#endif