#include "HeatFluxCal.h"


HeatFluxCal::HeatFluxCal(Inputs* input)
{

	resist = new ResistanceCal(input);

	UrbanCanyon = input->TemperatureCalculationParams["UrbanCanyon"]; // urban canyon toggle, 1 or 0 in config file

	SoilMSD = input->TemperatureCalculationParams["SoilMSD"];
	Soilheight = input->TemperatureCalculationParams["Soilheight"];		// average soil height  rcc 4/22/2020 updating aveHeight based on email w/ Ted et al 4/13/2020
	Soilalbedo = input->TemperatureCalculationParams["Soilalbedo"];                                 // soil effective albedo
	Soilemissivity = input->TemperatureCalculationParams["Soilemissivity"];
	// soil emissivity                                  
	Soila1 = input->TemperatureCalculationParams["Soila1"];
	Soila2 = input->TemperatureCalculationParams["Soila2"];
	Soila3 = input->TemperatureCalculationParams["Soila3"];

	// urban parameters
	Urban21albedo = input->TemperatureCalculationParams["Urban21albedo"];
	Urban21height = input->TemperatureCalculationParams["Urban21height"];
	Urban21roadwidth = input->TemperatureCalculationParams["Urban21roadwidth"];
	Urban21emissivity = input->TemperatureCalculationParams["Urban21emissivity"];
	Urban21depression = input->TemperatureCalculationParams["Urban21depression"];
	Urban21a1 = input->TemperatureCalculationParams["Urban21a1"];
	Urban21a2 = input->TemperatureCalculationParams["Urban21a2"];
	Urban21a3 = input->TemperatureCalculationParams["Urban21a3"];
	Urban21buildingP = input->TemperatureCalculationParams["Urban21buildingP"];
	//UrbanDepression=pm->get_depression_storage21();
	//aveHeight = folder->ParamDict["ImperP"]* UrbanbuildingP*Urbanheight;
	// parameters calculated based on the parameters above

	Urban22albedo = input->TemperatureCalculationParams["Urban22albedo"];
	Urban22height = input->TemperatureCalculationParams["Urban22height"];
	Urban22roadwidth = input->TemperatureCalculationParams["Urban22roadwidth"];
	Urban22emissivity = input->TemperatureCalculationParams["Urban22emissivity"];
	Urban22depression = input->TemperatureCalculationParams["Urban22depression"];
	Urban22a1 = input->TemperatureCalculationParams["Urban22a1"];
	Urban22a2 = input->TemperatureCalculationParams["Urban22a2"];
	Urban22a3 = input->TemperatureCalculationParams["Urban22a3"];
	Urban22buildingP = input->TemperatureCalculationParams["Urban22buildingP"];
	//Urban22Depression=pm->get_depression_storage22();


	Urban23albedo = input->TemperatureCalculationParams["Urban23albedo"];
	Urban23height = input->TemperatureCalculationParams["Urban23height"];
	Urban23roadwidth = input->TemperatureCalculationParams["Urban23roadwidth"];
	Urban23emissivity = input->TemperatureCalculationParams["Urban23emissivity"];
	Urban23depression = input->TemperatureCalculationParams["Urban23depression"];
	Urban23a1 = input->TemperatureCalculationParams["Urban23a1"];
	Urban23a2 = input->TemperatureCalculationParams["Urban23a2"];
	Urban23a3 = input->TemperatureCalculationParams["Urban23a3"];
	Urban23buildingP = input->TemperatureCalculationParams["Urban23buildingP"];
	//Urban23Depression=inp->pm->get_depression_storage23();


	Urban24albedo = input->TemperatureCalculationParams["Urban24albedo"];
	Urban24height = input->TemperatureCalculationParams["Urban24height"];
	Urban24roadwidth = input->TemperatureCalculationParams["Urban24roadwidth"];
	Urban24emissivity = input->TemperatureCalculationParams["Urban24emissivity"];
	Urban24depression = input->TemperatureCalculationParams["Urban24depression"];
	Urban24a1 = input->TemperatureCalculationParams["Urban24a1"];
	Urban24a2 = input->TemperatureCalculationParams["Urban24a2"];
	Urban24a3 = input->TemperatureCalculationParams["Urban24a3"];
	Urban24buildingP = input->TemperatureCalculationParams["Urban24buildingP"];
	//Urban24Depression=inp->pm->get_depression_storage24();
	//tree parameters

	Treea1 = input->TemperatureCalculationParams["Treea1"];
	Treea2 = input->TemperatureCalculationParams["Treea2"];
	Treea3 = input->TemperatureCalculationParams["Treea3"];

	Treeheight = input->TemperatureCalculationParams["Treeheight"];                         //average tree height
	Treealbedo = input->TemperatureCalculationParams["Treealbedo"];                         //effective albedo
	Treeemissivity = input->TemperatureCalculationParams["Treeemissivity"];                     //emissivity
	TreeSL = input->TemperatureCalculationParams["TreeMaxInterception"];

	// short vegetation parameters
	Shorta1 = input->TemperatureCalculationParams["ShortVegetationa1"];
	Shorta2 = input->TemperatureCalculationParams["ShortVegetationa2"];
	Shorta3 = input->TemperatureCalculationParams["ShortVegetationa3"];

	Shortheight = input->TemperatureCalculationParams["ShortVegetationheight"];                         //average tree height
	Shortalbedo = input->TemperatureCalculationParams["ShortVegetationalbedo"];                         //effective albedo
	Shortemissivity = input->TemperatureCalculationParams["ShortVegetationemissivity"];                    //emissivity
	ShortSL = input->TemperatureCalculationParams["ShortVegetationMaxInterception"];

	// water parameters
	Waterheight = input->TemperatureCalculationParams["Waterheight"];		// average water height  rcc 4/22/2020 updating aveHeight based on email w/ Ted et al 4/13/2020
	Wateralbedo = input->TemperatureCalculationParams["Wateralbedo"];
	Wateremissivity = input->TemperatureCalculationParams["Wateremissivity"];
	Watera1 = input->TemperatureCalculationParams["Watera1"];
	Watera2 = input->TemperatureCalculationParams["Watera2"];
	Watera3 = input->TemperatureCalculationParams["Watera3"];

}

void HeatFluxCal::assignUrbanParam(int land)
{
	if (land == 21)
	{
		Urbanalbedo = Urban21albedo;
		Urbanheight = Urban21height;
		Urbanroadwidth = Urban21roadwidth;
		Urbanemissivity = Urban21emissivity;
		UrbanDepression = Urban21depression;
		Urbana1 = Urban21a1;
		Urbana2 = Urban21a2;
		Urbana3 = Urban21a3;
		UrbanbuildingP = Urban21buildingP;
	}
	if (land == 22)
	{
		Urbanalbedo = Urban22albedo;
		Urbanheight = Urban22height;
		Urbanroadwidth = Urban22roadwidth;
		Urbanemissivity = Urban22emissivity;
		UrbanDepression = Urban22depression;
		Urbana1 = Urban22a1;
		Urbana2 = Urban22a2;
		Urbana3 = Urban22a3;
		UrbanbuildingP = Urban22buildingP;

	}
	if (land == 23)
	{
		Urbanalbedo = Urban23albedo;
		Urbanheight = Urban23height;
		Urbanroadwidth = Urban23roadwidth;
		Urbanemissivity = Urban23emissivity;
		UrbanDepression = Urban23depression;
		Urbana1 = Urban23a1;
		Urbana2 = Urban23a2;;
		Urbana3 = Urban23a3;
		UrbanbuildingP = Urban23buildingP;
	}
	if (land == 24)
	{
		Urbanalbedo = Urban24albedo;
		Urbanheight = Urban24height;
		Urbanroadwidth = Urban24roadwidth;
		Urbanemissivity = Urban24emissivity;
		UrbanDepression = Urban24depression;
		Urbana1 = Urban24a1;
		Urbana2 = Urban24a2;;
		Urbana3 = Urban24a3;
		UrbanbuildingP = Urban24buildingP;
	}

	//Parameterize impervious surfaces outside of NLCD 21 to 24
	if (land < 21 || land > 24)
	{
		Urbanalbedo = Urban21albedo;
		Urbanheight = Urban21height;
		Urbanroadwidth = Urban21roadwidth;
		Urbanemissivity = Urban21emissivity;
		UrbanDepression = Urban21depression;
		Urbana1 = Urban21a1;
		Urbana2 = Urban21a2;
		Urbana3 = Urban21a3;
		UrbanbuildingP = Urban21buildingP;
	}

	Urbanhwr = Urbanheight / Urbanroadwidth;
	//RVF = road view factor, based on Eq 12 of Kusaka et al. (2001)
	UrbanRVF = sqrt(Urbanhwr*Urbanhwr + 1) - Urbanhwr;
	//WVF = wall view factor, based on Eq 12 of Kusaka et al. (2001)
	UrbanWVF = 0.5*(Urbanhwr + 1 - sqrt(Urbanhwr + 1)) / Urbanhwr;
}

void HeatFluxCal::CalaveHeight(double treeP, double shortVegP, double soilP, double waterP, double imperP, int land)
{
	//Heights are based on equivalent roughness height, from Table 4.1 of R. Stully Meteorology book, ISBN 0-534-37214-7; 
	//Impervious cover (IC) height assumes landscape of 100% IC has obstructions. To simulate IC as a sea, create new Urbanheight = 0.001 m.

	//cte May 8, 2020
	//aveHeight is only a function of treeP and imperP if they cover 100% or more of the area
	if (treeP + imperP > 1) {
		//create extra version of variables treeP and imperP to temporarily modify them for single aveHeight calculation
		double treeP_extra = treeP;
		double imperP_extra = imperP;
		imperP_extra = 1 - treeP_extra;
		aveHeight = treeP_extra * Treeheight + imperP_extra * Urbanheight;
	} else {
		aveHeight = treeP * Treeheight + shortVegP * Shortheight + soilP * Soilheight + waterP * Waterheight + imperP * Urbanheight;
	}
	height = Urbanheight;
	if (land == 11 || land == 12)
	{
		height = 0.1;
	}
	if (land > 25)
	{
		if (treeP > 0)
			height = Treeheight;
		else
			height = Shortheight;
	}
	if (aveHeight < 0.001) 
		aveHeight = 0.001;
}


// just need to calculate once for each time step
void HeatFluxCal::VariableForAllfolders(int ts, Inputs *input)
{
	//LAI treated as time varying during transition dates, defined in Config XML as LeafOnDay and LeafOffDay
	TreeLAI= input->TreeLAI[ts];
	ShortLAI = input->ShortVegLAI[ts];
	downLW = input->DownLongWaveRadiation[ts];
	upLW = input->UpLongWaveRadiation[ts];
	DiffSWR = input->DiffuseShortWaveRadiation[ts];
	//Ta=inp->RW->getTair(ts)+273.15;
	//Td=inp->RW->getTdew(ts)+273.15;
	windsp = input->WindSp_mps[ts];
	//dirSW->calZenithAzimuth(ts);
}

void HeatFluxCal::assignRefTaTd(Inputs *input, int ts)
{
	Ta = (input->Tair[ts] - 32)*5.0 / 9.0 + 273.15;
	Td = (input->Tdew[ts] - 32)*5.0 / 9.0 + 273.15;

	//Error handling: Ta >= Td is the presumed condition, but weather data sometimes has rounding errors that violate this condition
	if (Td >= Ta)
	{
		Td = Ta;
		std::fstream fs;
		fs.open("InstanceTD=TA.txt", std::fstream::in | std::fstream::out | std::fstream::app);
		fs << "Timestep: " << ts << ",Td: " << Td << ",Ta: " << Ta << ",wateronImp: " << wateronImp << ",wateronSoil: " << wateronSoil << ",wateronShort: " << wateronShort << ",wateronTree: " << wateronTree << "\n";
		fs.close();
	} 
}

void HeatFluxCal::calDirSWRad(int folderID, Inputs *input, int timeStep, double &dirSWRadiation)
{
	//Eq 25 in Yang et al. (2013), adjust direct radiation based on topographic slope and aspect and solar angle for that timestep 
	dirSWRadiation = input->DirectShortWaveRadiation[timeStep] * ((sin(input->Slope[folderID]))*cos(input->Aspect[folderID])*sin(input->Zenith[timeStep])*input->CosAzimuth[timeStep] +
		sin(input->Slope[folderID])*sin(input->Aspect[folderID])*sin(input->Zenith[timeStep])*input->SinAzimuth[timeStep] +
		cos(input->Slope[folderID])*cos(input->Zenith[timeStep]));

	if (dirSWRadiation<0)
		dirSWRadiation = 0;
}

//only calculate once for each folder at each timestep, specific for each folder, but not involved in the iterations
void HeatFluxCal::StateCal(DataFolder *folder, int ts, Inputs *input, int folderID)// check curTimestepIndex curTimestepIndexboundaries localcal ??
{
	//Component S/Smax of Eq 22 in Yang et al. (2013)
	wateronTree = folder->VarDict["treeStoredW"] / TreeSL / TreeLAI;
	wateronShort = folder->VarDict["shortVegStoredW"] / ShortSL / ShortLAI;
	//Component D/Dmax of Eq 20 in Yang et al. (2013)
	wateronSoil = 1 - folder->VarVecDict["rootZoneStorDef_TI"][0] / SoilMSD; // available water in the soil for evaporate
	//Component S/Smax of Eq 19 in Yang et al. (2013)
	wateronImp = folder->VarDict["impDepStor_m"] / UrbanDepression;

	folder->VarDict["prevImp000"] = wateronImp;

	int land = input->NLCDLandCoverData[folderID];

	resist->calr_rural(windsp, TreeLAI, ShortLAI, aveHeight);  // calculate rural canopy flux resistance

	resist->calr_onwater(wateronSoil, TreeLAI, ShortLAI);  // calculate flux resistance that depends on water content

	calDirSWRad(folderID, input, ts, DirSWR);
	totalSWR = DirSWR + DiffSWR;

	double treeP = folder->ParamDict["TreeP"];
	double soilP = folder->ParamDict["SoilP"];
	double shortVegP = folder->ParamDict["ShortVegP"];
	double imperP = folder->ParamDict["ImperP"];
	double landc = folder->ParamDict["LandC"];
	double waterP = folder->ParamDict["WaterP"];
	if (folder->ParamDict["ImperP"] > 0.0001)
	{
		if ((land > 20) && (land < 25) && (UrbanCanyon == 1))
		{
			resist->calr_urban(windsp, TreeLAI, ShortLAI, aveHeight, Urbanhwr, height);
			//Algorithm used in PASATH (Yang et al. 2013) 
			//based on Urban Canopy Model by Kusaka et al. (2001), A simple single-layer urban canopy model for atmospheric models: Comparison with multi-layer and slab models, Boundary Layer Meteorol., 101(3), 329358.
			//based on Urban Canopy Model by Lee, S.H., and S.U. Park (2008), A vegetated urban canopy model for meteorological and environmental modelling, Boundary Layer Meteorol., 126(1), 73102.
			//RVF = road view factor
			double RVF = UrbanRVF;
			//WVF = wall view factor
			double WVF = UrbanWVF;
			//longwave downwelling
			double L = downLW;
			//urban emissivity
			double s = Urbanemissivity;  
			//albedo for road defined as 0.08 in Lee, S.-H., and S.-U. Park (2008), A vegetated urban canopy model for meteorological and environmental modelling, Boundary Layer Meteorol., 126(1), 73102.
			double siT = upLW + 0.08 / Urbanemissivity * totalSWR*(1 - Urbanalbedo);   //0.08 is a constant
			//longwave radiation on road
			double Lr = s * RVF*L - s * siT + s * s*(1 - RVF)*siT +
				s * (1 - s)*(1 - RVF)*WVF*L + s * s*(1 - s)*(1 - RVF)*(1 - 2 * WVF)*siT +
				s * (1 - s)*(1 - RVF)*WVF*s*siT;
			//longwave radiation on wall from 
			double Lw = s * WVF*L - s * siT + s * WVF*s*siT
				+ s * s*(1 - 2 * WVF)*siT + s * (1 - s)*RVF*WVF*L +
				s * (1 - s)*WVF*(1 - 2 * WVF)*L + s * s*(1 - s)*(1 - 2 * WVF)*(1 - 2 * WVF)*siT +
				s * s*(1 - s)*WVF*(1 - RVF)*siT + s * (1 - s)*WVF*(1 - 2 * WVF)*s*siT;

			//Defined in Eq 24 in Yang, Endreny, Nowak (2013)
			ImpNR = totalSWR * (1 - Urbanalbedo) + (1 - UrbanbuildingP)*(Lr + 2 * Urbanhwr*Lw) + UrbanbuildingP * (L - s * siT);
		}
		else
			//Defined in Eq 24 in Yang, Endreny, Nowak (2013)
			ImpNR = totalSWR * (1 - Urbanalbedo) + Urbanemissivity * downLW - Urbanemissivity * upLW;

		//Defined in Eq 29 in Yang, Endreny, Nowak (2013) 
		//Parameters a1, a2, a3 originally from concrete in Table 4 of Grimmond, C., and T. R. Oke (1999a), Heat storage in urban areas, J. Appl. Meteorol., 38(7), 922940.
		ImpDeltaQ = Urbana1 * ImpNR + Urbana2 * (ImpNR - folder->VarDict["ImpNR"]) + Urbana3;
		ImpC = pow(wateronImp, 2.0 / 3.0);

	}
	else
	{
		ImpNR = 0; ImpDeltaQ = 0; ImpC = 0;
	}

	//Tree part
	if (treeP > 0.0001)
	{
		//Defined in Eq 24 in Yang, Endreny, Nowak (2013) 
		TreeNR = totalSWR * (1 - Treealbedo) + Treeemissivity * downLW - Treeemissivity * upLW;
		//Defined in Eq 29 in Yang, Endreny, Nowak (2013) 
		//Parameters a1, a2, a3 originally modified from mixed forest in Table 4 of Grimmond, C., and T. R. Oke (1999a), Heat storage in urban areas, J. Appl. Meteorol., 38(7), 922940.
		TreeDeltaQ = Treea1 * TreeNR + Treea2 * (TreeNR - folder->VarDict["TreeNR"]) + Treea3;
		//Defined in Eq 22 in Yang, Endreny, Nowak (2013)
		//cte TreeCE = pow(wateronTree, (2.0 / 3.0)); //This form places resistance in remaining part of Eq 22
		TreeCE = pow(wateronTree, (2.0 / 3.0)) / resist->rtree;
		//Defined in Eq 23 in Yang, Endreny, Nowak (2013) 
		//cte TreeCT = (1 - pow(wateronTree, 2.0 / 3.0)); //This form places resistance in remaining part of Eq 23
		TreeCT = (1 - pow(wateronTree, 2.0 / 3.0)) / (resist->rtree + resist->rctree);
		TreeC = TreeCT + TreeCE;
	}
	else
	{
		TreeNR = 0; TreeDeltaQ = 0; TreeCE = 0; TreeCT = 0; TreeC = 0;
	}

	//Short vegetation part
	if (shortVegP > 0.0001)
	{
		//Defined in Eq 24 in Yang, Endreny, Nowak (2013) 
		ShortNR = totalSWR * (1 - Shortalbedo) + Shortemissivity * downLW - Shortemissivity * upLW;
		//Defined in Eq 29 in Yang, Endreny, Nowak (2013) 
		//Parameters a1, a2, a3 originally from short grass in Table 4 of Grimmond, C., and T. R. Oke (1999a), Heat storage in urban areas, J. Appl. Meteorol., 38(7), 922940.
		ShortDeltaQ = Shorta1 * ShortNR + Shorta2 * (ShortNR - folder->VarDict["ShortVegNR"]) + Shorta3;
		//Defined in Eq 22 in Yang, Endreny, Nowak (2013) 
		//cte ShortCE = pow(wateronShort, 2.0 / 3.0); //This is an optional expression within Eq 22
		ShortCE = pow(wateronShort, 2.0 / 3.0) / resist->rShortVeg;
		//Defined in Eq 23 in Yang, Endreny, Nowak (2013) 
		//cte ShortCT = (1 - pow(wateronShort, 2.0 / 3.0)); //This is an optional expression within Eq 22
		ShortCT = (1 - pow(wateronShort, 2.0 / 3.0)) / (resist->rShortVeg + resist->rcshort);
		ShortC = ShortCE + ShortCT;
	}
	else
	{
		ShortNR = 0; ShortDeltaQ = 0; ShortCE = 0; ShortCT = 0; ShortC = 0;
	}

	// soil part
	if (soilP > 0.0001)
	{
		//Defined in Eq 24 in Yang, Endreny, Nowak (2013) 
		SoilNR = 0.92*totalSWR*(1 - Soilalbedo) + 0.95*downLW - 0.95*upLW - 0.05*downLW;
		//Defined in Eq 29 in Yang, Endreny, Nowak (2013) 
		//Parameters a1, a2, a3 originally from bare soil in Table 4 of Grimmond, C., and T. R. Oke (1999a), Heat storage in urban areas, J. Appl. Meteorol., 38(7), 922940.
		SoilDeltaQ = Soila1 * SoilNR + Soila2 * (SoilNR - folder->VarDict["SoilNR"]) + Soila3;
		//Defined in Eq 20 in Yang, Endreny, Nowak (2013) 
		//cte SoilC = wateronSoil; //This is an optional expression within Eq 20
		SoilC = wateronSoil / (resist->rground + resist->rg);
	}  
	else
	{
		SoilNR = 0; SoilDeltaQ = 0; SoilC = 0;
	}

	// water part
	if (waterP > 0.0001)
	{
		WaterNR = 0.92*totalSWR*(1 - Wateralbedo) + 0.95*downLW - 0.95*upLW - 0.05*downLW;
		WaterDeltaQ = Watera1 * WaterNR + Watera2 * (WaterNR - folder->VarDict["WaterNR"]) + Watera3;
		WaterC = 1.0 / resist->rground;
	}
	else
	{
		WaterNR = 0; WaterDeltaQ = 0; WaterC = 0;
	}
}

// calculate mesoscale air temperature and dew point temperature 
void HeatFluxCal::MesoCal(DataFolder *folder, int ts)
{
	double treeP = folder->ParamDict["TreeP"];
	double soilP = folder->ParamDict["SoilP"];
	double shortVegP = folder->ParamDict["ShortVegP"];
	double imperP = folder->ParamDict["ImperP"];
	double waterP = folder->ParamDict["WaterP"];

	//Absolute Humidity (AH) Eq 18 from Yang, Endreny, and Nowak (2013), attributed to Lawrence (2005); units T = Kelvin, AH = kg/m^3
	//... Eq 18 combines Absolute Humidity Eq (AH = 0.00216679 * e/T; units kg*K/J) and Tetens Vapor Pressure Eq (e = 610.94 * exp[(17.27*(T-273.15))/(T-35.85)]; units Pa)
	//... Eq 18 coeficient 1.324 = 0.00216679 * 610.94; coefficient 610.94 comes from Lawrence (2005) Eq 6, attributed to Magnus Eq
	esatRTa = 1.324 / Ta * exp(17.27*(Ta - 273.15) / (Ta - 35.85));    // saturated vapor pressure converted to absolute humidity Kg/m^3) at Ta (K)														   
	Rea = 1.324 / Td * exp(17.27*(Td - 273.15) / (Td - 35.85));  // real vapor pressure coverted to absolute humidity Kg/m^3 at Td (K)
	delta = -esatRTa * (-4169.56 + Ta)*(-0.308 + Ta) / Ta / (-35.85 + Ta) / (-35.85 + Ta);

	if (imperP > 0.001)
	{
		//Combine Eq 9 and 19 from Yang, Endreny, Nowak (2013), note rimpH/rimpLE = 1 & ImpC = (S/Smax)^(2/3), expand, combine H terms on LHS, and isolate H 
		//1. ImpH = ImpNR - ImpDeltaQ - ImpLE = ImpNR - ImpDeltaQ - [(lamda*(esatRTa - Rea) / resist->rImp + lamda * delta*ImpH / rou / Cp)*ImpC]
		//2. ImpH = ImpNR - ImpDeltaQ - ImpC * lamda*(esatRTa - Rea) / resist->rImp - ImpC * lamda * delta*ImpH / rou / Cp
		//3. ImpH + ImpC * lamda * delta*ImpH / rou / Cp = ImpNR - ImpDeltaQ - ImpC * lamda*(esatRTa - Rea) / resist->rImp 
		//4. ImpH * (ImpC * lamda * delta / rou / Cp + 1) = ImpNR - ImpDeltaQ - ImpC * lamda*(esatRTa - Rea) / resist->rImp 
		//5. ImpH = (ImpNR - ImpDeltaQ - ImpC * lamda*(esatRTa - Rea) / resist->rImp) / (ImpC * lamda * delta / rou / Cp + 1)

		ImpH = (ImpNR - ImpDeltaQ - ImpC * lamda*(esatRTa - Rea) / resist->rimp) / (ImpC*lamda*delta / Cp / rou + 1);
		ImpLE = (lamda*(esatRTa - Rea) / resist->rimp + lamda * delta*ImpH / rou / Cp)*ImpC;
	}
	else
	{
		ImpH = 0.0; ImpLE = 0.0;
	}

	if (treeP > 0.0001)
	{
		//Combine Eq 9 and 22 and 23 from Yang, Endreny, Nowak (2013), note rTreeH/rTreeLE = 1 & TreeCE = (S/Smax)^(2/3)/rTree TreeCT = [1-(S/Smax)^(2/3)], expand, combine H terms on LHS, and isolate H 
		//1. TreeH = TreeNR - TreeDeltaQ - TreeLE = TreeNR - TreeDeltaQ - [(lamda*(esatRTa - Rea) / resist->rTree + lamda * delta*TreeH / rou / Cp)*TreeCE] - [(lamda*(esatRTa - Rea) / (resist->rTree + resist->rcTree) + lamda * delta*TreeH / rou / Cp)*TreeCT]
		//2. TreeH = TreeNR - TreeDeltaQ - TreeCE * lamda*(esatRTa - Rea) / resist->rTree - TreeCE* lamda * delta*TreeH / rou / Cp - TreeCT * lamda*(esatRTa - Rea) / (resist->rTree + resist->rcTree) - TreeCT* lamda * delta*TreeH / rou / Cp
		//3. TreeH + TreeCE* lamda * delta*TreeH / rou / Cp + TreeCT* lamda * delta*TreeH / rou / Cp = TreeNR - TreeDeltaQ - TreeCE * lamda*(esatRTa - Rea) / resist->rTree - TreeCT * lamda*(esatRTa - Rea) / (resist->rTree + resist->rcTree)
		//4. TreeH * (TreeCE* lamda * delta / rou / Cp + TreeCT* lamda * delta / rou / Cp + 1) = TreeNR - TreeDeltaQ - TreeCE * lamda*(esatRTa - Rea) / resist->rTree - TreeCT * lamda*(esatRTa - Rea) / (resist->rTree + resist->rcTree)
		//5. TreeH = (TreeNR - TreeDeltaQ - TreeCE * lamda*(esatRTa - Rea) / resist->rTree - TreeCT * lamda*(esatRTa - Rea) / (resist->rTree + resist->rcTree)) / (TreeCE* lamda * delta / rou / Cp + TreeCT* lamda * delta / rou / Cp + 1)
		//cte TreeH = (TreeNR - TreeDeltaQ - TreeCE * lamda * (esatRTa - Rea) / resist->rTree - TreeCT * lamda * (esatRTa - Rea) / (resist->rTree + resist->rcTree)) / (TreeCE * lamda * delta / rou / Cp + TreeCT * lamda * delta / rou / Cp + 1); //This form works with resistance is removed from TreeCT of Eq 22

		TreeH = (TreeNR - TreeDeltaQ - TreeC * lamda*(esatRTa - Rea)) / (TreeC*resist->rtree*lamda*delta / Cp / rou + 1);
		TreeLEE = (lamda*(esatRTa - Rea) + lamda * delta*TreeH*resist->rtree / rou / Cp)*TreeCE;
		TreeLET = (lamda*(esatRTa - Rea) + lamda * delta*TreeH*resist->rtree / rou / Cp)*TreeCT;
		TreeLE = TreeLEE + TreeLET;
	}
	else
	{
		TreeH = 0.0; TreeLEE = 0.0; TreeLET = 0.0; TreeLE = 0.0;
	}

	if (shortVegP > 0.0001)
	{
		//Combine Eq 9 and 22 from Yang, Endreny, Nowak (2013), note rShortH/rShortLE = 1 & ShortCE = (S/Smax)^(2/3)/rShortVeg ShortCT = [1-(S/Smax)^(2/3)], expand, combine H terms on LHS, and isolate H 
		//1. ShortH = ShortNR - ShortDeltaQ - ShortLE = ShortNR - ShortDeltaQ - [(lamda*(esatRTa - Rea) / resist->rShortVeg + lamda * delta*ShortH / rou / Cp)*ShortCE] - [(lamda*(esatRTa - Rea) / (resist->rShortVeg + resist->rcShortVeg) + lamda * delta*ShortH / rou / Cp)*ShortCT]
		//2. ShortH = ShortNR - ShortDeltaQ - ShortCE * lamda*(esatRTa - Rea) / resist->rShortVeg - ShortCE* lamda * delta*ShortH / rou / Cp - ShortCT * lamda*(esatRTa - Rea) / (resist->rShortVeg + resist->rcShortVeg) - ShortCT* lamda * delta*ShortH / rou / Cp
		//3. ShortH + ShortCE* lamda * delta*ShortH / rou / Cp + ShortCT* lamda * delta*ShortH / rou / Cp = ShortNR - ShortDeltaQ - ShortCE * lamda*(esatRTa - Rea) / resist->rShortVeg - ShortCT * lamda*(esatRTa - Rea) / (resist->rShortVeg + resist->rcShortVeg)
		//4. ShortH * (ShortCE* lamda * delta / rou / Cp + ShortCT* lamda * delta / rou / Cp + 1) = ShortNR - ShortDeltaQ - ShortCE * lamda*(esatRTa - Rea) / resist->rShortVeg - ShortCT * lamda*(esatRTa - Rea) / (resist->rShortVeg + resist->rcShortVeg)
		//5. ShortH = (ShortNR - ShortDeltaQ - ShortCE * lamda*(esatRTa - Rea) / resist->rShortVeg - ShortCT * lamda*(esatRTa - Rea) / (resist->rShortVeg + resist->rcShortVeg)) / (ShortCE* lamda * delta / rou / Cp + ShortCT* lamda * delta / rou / Cp + 1)
		//cte ShortH = (ShortNR - ShortDeltaQ - ShortCE * lamda * (esatRTa - Rea) / resist->rShortVeg - ShortCT * lamda * (esatRTa - Rea) / (resist->rShortVeg + resist->rcShortVeg)) / (ShortCE * lamda * delta / rou / Cp + ShortCT * lamda * delta / rou / Cp + 1); //This form works with resistance is removed from TreeCT of Eq 22

		ShortH = (ShortNR - ShortDeltaQ - ShortC * lamda*(esatRTa - Rea)) / (ShortC*resist->rShortVeg*lamda*delta / Cp / rou + 1);
		ShortLEE = (lamda*(esatRTa - Rea) + lamda * delta*ShortH*resist->rShortVeg / rou / Cp)*ShortCE;
		ShortLET = (lamda*(esatRTa - Rea) + lamda * delta*ShortH*resist->rShortVeg / rou / Cp)*ShortCT;
		ShortLE = ShortLEE + ShortLET;
	}
	else
	{
		ShortH = 0.0; ShortLEE = 0.0; ShortLET = 0.0; ShortLE = 0.0;
	}

	if (soilP > 0.0001)
	{
		//Combine Eq 9 and 20 from Yang, Endreny, Nowak (2013), note rSoilH/rSoilLE = 1 & SoilC = (1-D/Dmax) = wateronSoil, expand, combine H terms on LHS, and isolate H 
		//1. SoilH = SoilNR - SoilDeltaQ - SoilLE = SoilNR - SoilDeltaQ - [(lamda*(esatRTa - Rea) / (resist->rGround + resist->rG) + lamda * delta*SoilH / rou / Cp)*SoilC]
		//2. SoilH = SoilNR - SoilDeltaQ - SoilC * lamda*(esatRTa - Rea) / (resist->rGround + resist->rG) - SoilC* lamda * delta*SoilH / rou / Cp
		//3. SoilH + SoilC* lamda * delta*SoilH / rou / Cp = SoilNR - SoilDeltaQ - SoilC * lamda*(esatRTa - Rea) / (resist->rGround + resist->rG) 
		//4. SoilH * (SoilC* lamda * delta / rou / Cp + 1) = SoilNR - SoilDeltaQ - SoilC * lamda*(esatRTa - Rea) / (resist->rGround + resist->rG)
		//5. SoilH = (SoilNR - SoilDeltaQ - SoilC * lamda*(esatRTa - Rea) / (resist->rGround + resist->rG)) / (SoilC * lamda * delta / rou / Cp + 1)
		//cte SoilH = (SoilNR - SoilDeltaQ - SoilC * lamda * (esatRTa - Rea) / (resist->rGround + resist->rG)) / (SoilC * lamda * delta / rou / Cp + 1); //This form works with resistance is removed from SoilC
		
		SoilH = (SoilNR - SoilDeltaQ - SoilC * lamda*(esatRTa - Rea)) / (SoilC*lamda*delta*resist->rground / Cp / rou + 1);
		SoilLE = (lamda*(esatRTa - Rea) + lamda * delta*SoilH*resist->rground / rou / Cp)*SoilC;
	}
	else
	{
		SoilH = 0.0; SoilLE = 0.0;
	}

	if (waterP > 0.0001)
	{
		//Combine Eq 9 and 20 (modified for water) from Yang, Endreny, Nowak (2013), note rWaterH/rWaterLE = 1 & WaterC = 1, expand, combine H terms on LHS, and isolate H 
		//1. WaterH = WaterNR - WaterDeltaQ - WaterLE = WaterNR - WaterDeltaQ - [(lamda*(esatRTa - Rea) / resist->rGround  + lamda * delta*WaterH / rou / Cp)*WaterC]
		//2. WaterH = WaterNR - WaterDeltaQ - WaterC * lamda*(esatRTa - Rea) / resist->rGround - WaterC* lamda * delta*WaterH / rou / Cp
		//3. WaterH + WaterC* lamda * delta*WaterH / rou / Cp = WaterNR - WaterDeltaQ - WaterC * lamda*(esatRTa - Rea) / resist->rGround 
		//4. WaterH * (WaterC* lamda * delta / rou / Cp + 1) = WaterNR - WaterDeltaQ - WaterC * lamda*(esatRTa - Rea) / resist->rGround 
		//5. WaterH = (WaterNR - WaterDeltaQ - WaterC * lamda*(esatRTa - Rea) / resist->rGround) / (WaterC * lamda * delta / rou / Cp + 1)

		WaterH = (WaterNR - WaterDeltaQ - WaterC * lamda*(esatRTa - Rea)) / (WaterC*lamda*delta*resist->rground / Cp / rou + 1);
		WaterLE = (lamda*(esatRTa - Rea) + lamda * delta*WaterH*resist->rground / rou / Cp)*WaterC;
	}
	else
	{
		WaterH = 0.0; WaterLE = 0.0;
	}

	H = imperP * ImpH + treeP * TreeH + shortVegP * ShortH + soilP * SoilH + waterP * WaterH;
	LE = imperP * ImpLE + treeP * TreeLE + shortVegP * ShortLE + soilP * SoilLE + waterP * WaterLE;

	Tb = Ta - H * resist->rcanopy / rou / Cp;
	Eb = Rea - LE * resist->rcanopy / lamda;
}

void HeatFluxCal::IterationCalTb(DataFolder *folder, double ts)
{
	// uncomment this part for atomsphere stability correction
	Tb = Ta; // set the initial condition that Tb=Ta, then the F=1
	Tb_i = 0;
	int n = 0;
	while (abs(Tb_i - Tb) > 0.1 && n < 100)
	{
		Tb_i = Tb;
		resist->cal_factors(Tb_i, Ta, windsp, aveHeight, 200);
		MesoCal(folder, ts);
		n++;
	}

}

bool HeatFluxCal::IterationCalTbTemp(DataFolder *folder, double ts)
{
	// uncomment this part for atomsphere stability correction
	Tb = Ta; // set the initial condition that Tb=Ta, then the F=1
	Tb_i = 0;
	int n = 0;
	while (abs(Tb_i - Tb) > 0.1 && n < 100)
	{
		Tb_i = Tb;
		resist->cal_factors(Tb_i, Ta, windsp, aveHeight, 200);
		MesoCal(folder, ts);
		n++;
	}
	if (abs(Ta - Tb) > 30)
	{
		//Tb = Ta;
		return true;
	}
	return false;
}

void HeatFluxCal::savefolderValue(DataFolder *folder, DataFolder* reffolder, int timestep, int index)
{

	folder->VarDict["ImperviousH"] = ImpH;
	folder->VarDict["ImperviousLE"] = ImpLE;

	folder->VarDict["TreeH"] = TreeH;
	//std::cout << folder->VarDict["TreeH"] << std::endl;
	folder->VarDict["TreeLE"] = TreeLE;
	folder->VarDict["TreeLEE"] = TreeLEE;
	folder->VarDict["TreeLET"] = TreeLET;

	folder->VarDict["ShortVegH"] = ShortH;
	folder->VarDict["ShortVegLE"] = ShortLE;
	folder->VarDict["ShortVegLEE"] = ShortLEE;
	folder->VarDict["ShortVegLET"] = ShortLET;


	folder->VarDict["SoilNR"] = SoilNR;
	folder->VarDict["SoilH"] = SoilH;
	folder->VarDict["SoilLE"] = SoilLE;

	folder->VarDict["WaterNR"] = WaterNR;
	folder->VarDict["WaterH"] = WaterH;
	folder->VarDict["WaterLE"] = WaterLE;

	folder->VarDict["H"] = H;
	folder->VarDict["LE"] = LE;
	folder->VarDict["Tb"] = Tb;
	folder->VarDict["AirT"] = Ta;
	folder->VarDict["Td"] = Td;
	//Absolute Humidity (AH) Eq 18 from Yang, Endreny, and Nowak (2013), attributed to Lawrence (2005); units T = Kelvin, AH = kg/m^3
	//... Eq 18 combines Absolute Humidity Eq (AH = 0.00216679 * e/T; units kg*K/J) and Tetens Vapor Pressure Eq (e = 610.94 * exp[(17.27*(T-273.15))/(T-35.85)]; units Pa)
	//... Eq 18 coeficient 1.324 = 0.00216679 * 610.94; coefficient 610.94 comes from Lawrence (2005) Eq 6, attributed to Magnus Eq

	folder->VarDict["AirE"] = 1.324 / Td * exp(17.27*(Td - 273.15) / (Td - 35.85));
	folder->VarDict["Eb"] = Eb;

	folder->VarDict["DeltaQTree0"] = TreeDeltaQ;
	folder->VarDict["DeltaQTree1"] = Treea1 * TreeNR;
	folder->VarDict["DeltaQTree2"] = Treea2 * (TreeNR - folder->VarDict["TreeNR"]);
	folder->VarDict["DeltaQTree3"] = Treea3;
	folder->VarDict["TreeNR"] = TreeNR;

	folder->VarDict["DeltaQShortVeg0"] = ShortDeltaQ;
	folder->VarDict["DeltaQShortVeg1"] = Shorta1 * ShortNR;
	folder->VarDict["DeltaQShortVeg2"] = Shorta2 * (ShortNR - folder->VarDict["ShortVegNR"]);
	folder->VarDict["DeltaQShortVeg3"] = Shorta3;
	folder->VarDict["ShortVegNR"] = ShortNR;

	folder->VarDict["DeltaQImpervious0"] = ImpDeltaQ;
	folder->VarDict["DeltaQImpervious1"] = Urbana1 * ImpNR;
	folder->VarDict["DeltaQImpervious2"] = Urbana2 * (ImpNR - folder->VarDict["ImpNR"]);
	folder->VarDict["DeltaQImpervious3"] = Urbana3;
	folder->VarDict["ImpNR"] = ImpNR;

	folder->VarDict["ImpDeltaQ"] = ImpDeltaQ;
	folder->VarDict["TreeDeltaQ"] = TreeDeltaQ;
	folder->VarDict["ShortDeltaQ"] = ShortDeltaQ;
	folder->VarDict["SoilDeltaQ"] = SoilDeltaQ;
	folder->VarDict["WaterDeltaQ"] = WaterDeltaQ;
	
	// cte can use for debugging, code by sc 2019
	/*if (index == 249)
	{
		std::fstream fs;
		fs.open("wateronimp249.txt", std::fstream::in | std::fstream::out | std::fstream::app);
		fs << wateronImp << std::endl;
		fs.close();
	}*/

}

// calculate local canopy temperature and humidity
void HeatFluxCal::LocalTCal(DataFolder *folder, DataFolder* reffolder, int ts, int n_iters) {
	//	resist->cal_factors(Ta,Ta,windsp,aveHeight);

	double Tb_obs = reffolder->VarDict["Tb"];   // the calculated mesoscale air temperature
	double eb_obs = reffolder->VarDict["Eb"];   // the calculated mesoscale air humidity

	double Ta_est = reffolder->VarDict["AirT"];   // the start value of the estimated air temperature of a folder
	double Td_est = reffolder->VarDict["Td"];     // the start value of the estimated dew point temperature of a folder
												  //changed below code by Vamsi to get the number of iterations from config file
												  //int n_iters = inp->getPM()->get_iterationCount();      // total iteration number for searching the solution
	double alamda = 0.1;   // the lamda value in LM method
	double w1 = 10000;    // the weight for eb 
	double W[2][2];     // the weight matrix
	double J[2][2];
	double H[2][2];
	double H_lm[2][2];
	double e = 0.0;    // error value
	double d1 = 0.0;
	double d2 = 0.0;
	W[0][0] = 1;
	W[0][1] = 0;
	W[1][0] = 0;
	W[1][1] = w1;  //give values to the weight matrix member

	int updateJ = 1;

	double dTa = 0.01;     // for numerical diff
	double dTd = 0.01;     // for numerical diff

	for (int it = 0; it < n_iters; it++)
	{
		if (updateJ == 1)
		{
			Ta = Ta_est;
			Td = Td_est;
			IterationCalTb(folder, ts);
			////	MesoCal(folder,ts);
			double Tb0 = Tb; double eb0 = Eb;

			Ta = Ta_est + dTa;
			IterationCalTb(folder, ts);
			//MesoCal(folder,ts);
			double Tb1 = Tb; double eb1 = Eb;

			Ta = Ta_est; Td = Td_est + dTd;
			IterationCalTb(folder, ts);
			//MesoCal(folder,ts);
			double Tb2 = Tb; double eb2 = Eb;


			J[0][0] = (Tb1 - Tb0) / dTa;
			J[0][1] = (Tb2 - Tb0) / dTd;
			J[1][0] = (eb1 - eb0) / dTa;
			J[1][1] = (eb2 - eb0) / dTd;

			d1 = Tb_obs - Tb0;
			d2 = (eb_obs - eb0)*w1;

			H[0][0] = J[0][0] * J[0][0] + J[1][0] * J[1][0] * w1;
			H[0][1] = J[0][0] * J[0][1] + J[1][0] * J[1][1] * w1;
			H[1][0] = J[0][1] * J[0][0] + J[1][1] * J[1][0] * w1;
			H[1][1] = J[0][1] * J[0][1] + J[1][1] * J[1][1] * w1;

			if (it == 0)
				e = d1 * d1 + d2 * d2;

		}

		H_lm[0][0] = H[0][0] + alamda;
		H_lm[0][1] = H[0][1];
		H_lm[1][0] = H[1][0];
		H_lm[1][1] = H[1][1] + alamda;

		double bb = 1 / (H_lm[0][0] * H_lm[1][1] - H_lm[0][1] * H_lm[1][0]);
		double dp1 = bb * (H_lm[1][1] * (J[0][0] * d1 + J[1][0] * d2) - H_lm[0][1] * (J[0][1] * d1 + J[1][1] * d2));
		double dp2 = bb * (-H_lm[1][0] * (J[0][0] * d1 + J[1][0] * d2) + H_lm[0][0] * (J[0][1] * d1 + J[1][1] * d2));
		double Ta_lm = Ta_est + dp1;
		double Td_lm = Td_est + dp2;

		Ta = Ta_lm;
		Td = Td_lm;

		IterationCalTb(folder, ts);
		//	MesoCal(folder,ts);

		double Tb_est_lm = Tb;
		double eb_est_lm = Eb;
		double d_lm1 = Tb_obs - Tb_est_lm;
		double d_lm2 = (eb_obs - eb_est_lm)*w1;


		double  e_lm = d_lm1 * d_lm1 + d_lm2 * d_lm2;

		if (e_lm < e)
		{
			alamda = alamda / 10;
			Ta_est = Ta_lm;
			Td_est = Td_lm;
			e = e_lm;
			updateJ = 1;
		}
		else
		{
			updateJ = 0;
			alamda = alamda * 10;
		}

	}

}
