#ifndef TestSimulation_H
#define TestSimulation_H
#include "Inputs\Inputs.h"
#include "DataOrganizer.h"
#include "LogMessage.h"

class TestSimulation
{
public:
	static void Go(DataOrganizer *organizer, Inputs *input, std::string inputDirectory);
	static void RunStatisticalModel(DataOrganizer *organizer, Inputs *input, std::string inputDirectory);
	static void RunTemperatureSpatialModel(DataOrganizer *organizer, Inputs *input, std::string inputDirectory);
	static void RunCoolRiverModel(DataOrganizer *organizer, Inputs *input, std::string inputDirectory);

private:
	static void writeStatisticalOutput(DataOrganizer *organizer, Inputs *input);
	static void writeExtendedOutput(DataOrganizer *organizer, Inputs *input);
	static void writeNoExtendedOutput(DataOrganizer *organizer, Inputs *input);
	static void runCalculations(DataFolder *folder, Inputs *input, int timeStep, std::vector<DataFolder *> &stafolders);
	//static void runGICalculations(DataFolder *folder, Inputs *input, int timeStep, std::vector<DataFolder*> &stafolders);
	static void twoDwriter(int sizeX, int sizeY, string a, string b, vector<vector<double>> &vector, string title, string OutputDir);

	static void runProcesses(DataFolder *folder, Inputs *input, int timeStep, std::vector<DataFolder *> &stafolders);
};

#endif