#ifndef UNSATOF_H
#define UNSATOF_H
//////////////////////////////////////////////////////////////////////////////////
//																		        //
// UnsatZonePerviousFlow.h - Calculates unsaturated zone Pervious flow          //																		   
// ver 1.0                                                                      //
// Language:    Visual C++ 2010                                                 //
// Platform:    MacBookPro5,4  Win7										        //
// Application: HydroPrime/iHydro Version6, Summer 2012                         //
// Programmer:  				        //																	   	
//////////////////////////////////////////////////////////////////////////////////
/*
  Origin:
  ==================
  Program: iHydro Version 5 & iHydro Version 4.5
  
  Source Code File(s): 
					  V5- runsatzone.cpp, (line 115) PerviousQ()
					  V4.5- runsatzone.cpp, (line 161) PerviousQ()
  
  Author(s): Jun Wang, jwang06@mailbox.syr.edu, V4/V4.5
			 Yang Yang, yyang31@syr.edu, V5
			  	
						*Incorporated calculations into new architecture
  Creation Date: Summer 2000

  Publication(s): Jun Wang PHDThesis

  Module Operations: 
  ==================
  Calculates Pervious flow for fully saturated area.

  Public Interface:
  =================
  UnsatZonePerviousFlowCalc(Inputs *input, Repo *repo);
  void calculate(Inputs *input, DataFolder *folder, int timeStep);

  Build Process:
  ==============
  Required files
	-ICalc.h, InputsRepository.h, ResultsRepository.h, UnsatZonePerviousFlow.cpp 
				
  Build commands 
    - devenv hydroprime.sln
   
  Maintenance History:
  ====================

 */

#include "../Inputs/Inputs.h"
#include "../DataFolder.h"


class UnsatZonePerviousFlowCalc
{
	public:
		static void calculate(Inputs *input, DataFolder *folder, int timeStep);
		static void storeValues(Inputs *input, DataFolder *folder, int timeStep);
		static void statisticalCalculate(Inputs *input, DataFolder *folder, int timeStep);
		static void spatialCalculate(Inputs *input, DataFolder *folder, int timeStep);
};



#endif