#include "UnsatZoneSoilMoistureDeficitExpDecayCalc.h"


//------------------- calculate local soil moisture deficit for each ln(a/tanB) increment ---------------------
// this is based on Yang's version 5  TestWeather runsatzoneE.cpp
//void runsatzoneE::localSoilMD () {
void UnsatZoneSoilMoistureDeficitExpDecayCalc::calculate(Inputs *input, DataFolder *folder, int timeStep)
{
	double mM = folder->ParamDict["m"];
	double aveSMD_value = folder->VarDict["aveSMD"];
	if (folder->ParamStringDict["Type"] != "BulkArea") {
		aveSMD_value = folder->VarDict["AveSMD_GI"];
	}
   	for (int ia=0; ia<input->IndexAreaSize; ia++)
	{
		if (timeStep == 0)
		{
			folder->VarVecDict["localSMD_TI"].push_back(0.0);
		}
		if(input->IndexAreaSize > 1)
			folder->VarVecDict["localSMD_TI"][ia] = aveSMD_value + mM * (input->AverageIndex - input->Index[ia]); // real for coresponding index
		else
			folder->VarVecDict["localSMD_TI"][ia] = aveSMD_value + mM * (input->AverageIndex - input->Index[folder->VarDict["position"]]); // real for coresponding index

		// Updating the local SMD - cannot be less then 0 - set to 0
		if (folder->VarVecDict["localSMD_TI"][ia] < 0.0)
			folder->VarVecDict["localSMD_TI"][ia] = 0.0;

	}


	//Reza, for debugging
	//if (folder->ParamStringDict["Type"] == "BulkArea") {
	//	double sum = 0;
	//	for (int ia = 0; ia < input->IndexAreaSize; ia++) {
	//		sum += folder->VarVecDict["localSMD_TI"][ia];
	//	}
	//	sum /= input->IndexAreaSize;
	//	input->RepoDict["local_BA_TI"] = sum;
	//}
}	


// see UnsatZoneSoilMoistureDeficit.h for interface
// remeber to make inputs repository and results repository a friend of this class...inputsrepository.cpp resultsrepository.cpp
// see UnsatZoneSoilMoistureDeficit.cpp for implentation help 
// incporporate equation from Version 5 line 49 void runsatzoneE::localSoilMD ()


/* Old V5 Functions:
void runsatzoneE::localSoilMD () {


   	for (int ia=0; ia<topIndex.size(); ia++)
	{
		localSMD[ia] = aveSMD + mM * (topIndex.getAveIndex() - topIndex[ia]) ;
		if( localSMD[ia] < 0.0 )         
			localSMD[ia] = 0.0;

	}

}	*/
