#include "UnsatZoneStorageCalc.h"


void UnsatZoneStorageCalc::calculate(Inputs *input, DataFolder *folder, int timeStep)
{


	// This for loop runs for each member of the Topographic Index Distribution - typically 30 values
	// The distributed runs only have an Index Area vector of 1, with an area equal to the folder size?  - so this is only stepped through once per folder
	for(int ia=0; ia<input->IndexAreaSize; ia++)
	{
		if (timeStep == 0)
		{
			folder->VarVecDict["unsatZoneStor_TI"].push_back(0.0);
			folder->VarVecDict["satExRunoff_TI"].push_back(0.0);
		}
		// Setting the initial overland flow equal to zero
		// stored by folder and TI
		folder->VarVecDict["satExRunoff_TI"][ia] = 0.0;

		// Updates the unsaturated zone storage (previous UszStorage(stored by folder, TI) + rootzone flow(TI), stored by folder, TI)
		folder->VarVecDict["unsatZoneStor_TI"][ia] += folder->VarVecDict["rootZoneQ_TI"][ia];   // add flow from root zone


		// Added to the disributed version for tracking distributed unsat zone storage for each call across all timesteps
		// repo->unsaturatedZone.modifyUszStorage_Dist(stafolders, timeStep, repo->unsaturatedZone.getUszStorage(stafolders, 0));

		// if (UszStorage (folder key, TI) > LocalSMD (folder key, TI))
		if (folder->VarVecDict["unsatZoneStor_TI"][ia] > folder->VarVecDict["localSMD_TI"][ia])
		{
			// Set the saturation excess pervious (overland) flow = difference between the Unsaturated Zone Storage and the Local Soil Moisture Deficit), stored by folder, TI 
			folder->VarVecDict["satExRunoff_TI"][ia] = folder->VarVecDict["unsatZoneStor_TI"][ia] - folder->VarVecDict["localSMD_TI"][ia];  // calculate Pervious flow for ln(a/tanB) increment
			// Set the unsaturated zone storage to Local Soil Mositure Deficit
            folder->VarVecDict["unsatZoneStor_TI"][ia] = folder->VarVecDict["localSMD_TI"][ia];               // unsaturated zone storage <= 
			            
		}

		// if the UszStorage < LocalSMD after the rootzone flow is added, then it is just as is
	}
	double temp = 0.0;

}

